From 25221c110bba3d2da12b4ba03007b7c54ada5347 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 25 2020 06:20:17 +0000
Subject: [PATCH 56/2232] Merge pull request #41 from dtolnay/canonicalize


Remove reliance on fs::canonicalize on Windows
---

diff --git a/src/paths.rs b/src/paths.rs
index f253939..e318664 100644
--- a/src/paths.rs
+++ b/src/paths.rs
@@ -44,7 +44,7 @@ fn try_symlink_header(path: &Path, original: &Path) -> Result<()> {
 fn relative_to_parent_of_target_dir(original: &Path) -> Result<PathBuf> {
     let target_dir = target_dir()?;
     let mut outer = target_dir.parent().unwrap();
-    let original = original.canonicalize()?;
+    let original = canonicalize(original)?;
     loop {
         if let Ok(suffix) = original.strip_prefix(outer) {
             return Ok(suffix.to_owned());
@@ -71,7 +71,7 @@ pub(crate) fn include_dir() -> Result<PathBuf> {
 }
 
 fn target_dir() -> Result<PathBuf> {
-    let mut dir = out_dir()?.canonicalize()?;
+    let mut dir = out_dir().and_then(canonicalize)?;
     loop {
         if dir.ends_with("target") {
             return Ok(dir);
@@ -81,3 +81,17 @@ fn target_dir() -> Result<PathBuf> {
         }
     }
 }
+
+#[cfg(not(windows))]
+fn canonicalize(path: impl AsRef<Path>) -> Result<PathBuf> {
+    Ok(fs::canonicalize(path)?)
+}
+
+#[cfg(windows)]
+fn canonicalize(path: impl AsRef<Path>) -> Result<PathBuf> {
+    // Real fs::canonicalize on Windows produces UNC paths which cl.exe is
+    // unable to handle in includes. Use a poor approximation instead.
+    // https://github.com/rust-lang/rust/issues/42869
+    // https://github.com/alexcrichton/cc-rs/issues/169
+    Ok(env::current_dir()?.join(path))
+}

